<template>
<div :class="wrapperClass"
@click="onWrapperClick">
  <button :class="buttonClass">
    {{ buttonValue }}
  </button>
</div>
</template>

<script>
// TODO: Remove underline button?
// TODO: Remove select button?

export default {
  name: 'AppButton',
  props: {
    buttonType: {
      type: String,
      required: true,
      validator(value) {
        return [
          'link',
          'select',
          'floating',
        ].indexOf(value) !== -1;
      },
    },
    buttonValue: {
      type: String,
      default: '',
      required: false,
    },
    isSelected: {
      type: Boolean,
      required: this.buttonType === 'select',
    },
  },
  computed: {
    buttonClass() {
      return {
        base: true,
        link: this.buttonType === 'link',
        select: this.buttonType === 'select',
        floating: this.buttonType === 'floating',
      };
    },
    wrapperClass() {
      return {
        wrapper: true,
        'is-selected': this.isSelected,
      };
    },
  },
  methods: {
    onWrapperClick() {
      this.$emit('click');
    },
  },
};
</script>

<style lang="scss" scoped>
@import '~styles/colors.scss';

.wrapper {
  background-image: none !important; /* gGradient in the parent element looks broken without this */
}

.base {
  margin: 0;
  padding: 0;

  background-color: transparent;

  font-weight: 700;
  font-size: inherit;
  transition: 0.2s;
}

.base:hover {
  cursor: pointer;
}

.base:focus {
  outline: transparent;
}

/* <Link Button> */
.link {
  border: none;

  font-size: 1.2em;
  font-weight: 700;
  color: inherit;
}

.link:hover {
  opacity: 0.7;
}
/* </Link Button> */

/* <Select Button> */
.wrapper {
  .select {
    opacity: 0.7;
  }
}

.wrapper::after {
  display: block;
  height: 1px;
  width: 0;
  margin: auto;

  content: ' ';

  transition: 0.3s ease-out width;
}

.wrapper.is-selected {
  .select {
    opacity: 1.0;
  }
}

.wrapper.is-selected::after {
  width: 100%;
  background: $button-is-selected;
}

.select {
  padding: 0 0 12px 0;

  border: none;

  font-weight: 700;
  color: inherit;
}

.select:hover {
  opacity: 1.0;
}
/* </Select Button> */

/* <Floating Button> */
.floating {
  padding: 0.875em 1.25em;

  border-radius: 1.5em;

  font-weight: 700;
  color: inherit;
  background-color: $button-floating;

  border: none;

  box-shadow: 0px 6px 20px $button-floating;
}

.floating:hover {
  box-shadow: 0 8px 20px $button-floating;
}
/* </Floating Button> */
</style>
